Subject: Re: RFC: rtnetlink problems with Cisco enic and VFs

From: Greg Rose <[email-masked]>
Date: Tue, 22 Apr 2014 17:04:38 -0700

On Wed, 23 Apr 2014 09:26:06 +1000
David Gibson <[email-masked]> wrote:

> On Tue, 22 Apr 2014 14:12:00 -0400 (EDT)
> David Miller <[email-masked]> wrote:
> 
> > From: Ben Hutchings <[email-masked]>
> > Date: Tue, 22 Apr 2014 19:03:19 +0100
> > 
> > > On Tue, 2014-04-22 at 14:14 +1000, David Gibson wrote:
> > >> I believe I've found a problem with netlink handling which can be
> > >> triggered on Cisco enic devices with a large number (30-40) of
> > >> virtual functions.  I believe this is the cause of a real
> > >> customer problem we've seen.
> > >> 
> > >>  * When requesting a list of interfaces with RTM_GETLINK, enic
> > >> devices (and currently, _only_ enic devices) report IFLA_VF_PORTS
> > >>    information 
> > >> 
> > >>  * IFLA_VF_PORTS information has at least 90 bytes ber virtual
> > >> function
> > >> 
> > >>  * Unlike IFLA_VFINFO_LIST, the ports information is always
> > >> reported, regardless of the setting of the IFLA_EXT_MASK
> > >> parameter
> > > [...]
> > > 
> > > So I think you should make reporting of IFLA_VF_PORTS dependent
> > > on the same flag as IFLA_VFINFO_LIST.
> > 
> > I think that's what we'll have to do.
> 
> Ok, makes logical sense.
> 
> But does anyone know what tools make use of the IFLA_VF_PORTS
> information?  Do they set the IFLA_EXT_MASK already?
> 

So far as I know only the IP route tool 'ip link' sets that.  In fact,
that's the reason I had to add it some number of years and months ago
was because there were tools that didn't expect to get all the
additional VF info and those tools were getting borked by all the
additional goo sent up for VFs.

Beyond that who knows what anyone's been up to with other tools in
other places?

- Greg